Draft BSpline
|
Menu location |
---|
Drafting → B-spline 2D Drafting → B-spline |
Workbenches |
Draft, BIM |
Default shortcut |
B S |
Introduced in version |
0.7 |
See also |
Draft Wire, Draft CubicBezCurve, Draft BezCurve |
Description
The Draft BSpline command creates a B-spline curve from several points.
The Draft BSpline command specifies the exact points through which the curve will pass. The Draft BezCurve and the Draft CubicBezCurve commands, on the other hand, use control points to define the position and curvature of the spline.
Spline defined by multiple points
Usage
See also: Draft Tray, Draft Snap and Draft Constrain.
- There are several ways to invoke the command:
- The B-spline task panel opens. See Options for more information.
- Pick the first point in the 3D view, or type coordinates and press the
Enter point button.
- Pick additional points in the 3D view, or type coordinates and press the
Enter point button.
- Press Esc or the Close button to finish the command.
Options
The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts (for version 1.0).
- To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the
Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
- Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, coordinates are relative to the last point, if available, else they are relative to the coordinate system origin.
- Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
- Press F or click the Filled checkbox to toggle filled mode. If filled mode is on, the created spline will have DataMake Face set to
true
and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting spline with a face will not display properly, for such a spline DataMake Face must be set tofalse
. - Press N or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after using
Finish or
Close, or after creating a closed spline by snapping to the first point of the spline, allowing you to continue creating splines.
- Press / or the
Undo button to undo the last point.
- Press A or the
Finish button to finish the command and leave the spline open.
- Press O or the
Close button to finish the command and close the spline. A closed spline can also be created by snapping to the first point of the spline.
- Press W or the
Wipe button to delete the curve segments already placed, but keep working from the last point.
- Press U or the
Set WP button to adjust the current working plane in the orientation defined by the last and the previous point.
- Press S to switch Draft snapping on or off.
- Press Esc or the Close button to finish the command.
Notes
- A Draft BSpline can be edited with the Draft Edit command.
- A Draft BSpline can be converted to a Draft Wire with the Draft WireToBSpline command.
Properties
See also: Property editor.
A Draft BSpline object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:
Data
Draft
- DataArea (
Area
): (read-only) specifies the area of the face of the spline. The value will be0.0
if DataMake Face iffalse
or the face cannot be created. - DataClosed (
Bool
): specifies if the spline is closed or not. If the spline is initially open this value isfalse
, setting it totrue
will draw a curve segment to close the spline. If the spline is initially closed this value istrue
, setting it tofalse
will remove the last curve segment and make the spline open. - DataMake Face (
Bool
): specifies if the spline makes a face or not. If it istrue
a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed istrue
and if the spline does not self-intersect. - DataParameterization (
Float
): affects the shape of the spline. - DataPoints (
VectorList
): specifies the points of the spline in its local coordinate system.
View
Draft
- ViewArrow Size (
Length
): specifies the size of the symbol displayed at the end of the spline. - ViewArrow Type (
Enumeration
): specifies the type of symbol displayed at the end of the spline, which can beDot
,Circle
,Arrow
,Tick
orTick-2
. - ViewEnd Arrow (
Bool
): specifies whether to show a symbol at the end of the spline, so it can be used as an annotation line. - ViewPattern (
Enumeration
): specifies the Draft Pattern with which to fill the face of the closed spline. This property only works if DataMake Face istrue
and if ViewDisplay Mode isFlat Lines
. - ViewPattern Size (
Float
): specifies the size of the Draft Pattern.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To create a Draft BSpline use the make_bspline
method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBSpline
method.
bspline = make_bspline(pointslist, closed=False, placement=None, face=None, support=None)
bspline = make_bspline(Part.Wire, closed=False, placement=None, face=None, support=None)
- Creates a
bspline
object from the given list of points,pointslist
.- Each point in the list is defined by its
FreeCAD.Vector
, with units in millimeters. - Alternatively, the input can be a
Part.Wire
, from which points are extracted.
- Each point in the list is defined by its
- If
closed
isTrue
, or if the first and last points are identical, the spline is closed. - If
placement
isNone
the spline is created at the origin. - If
face
isTrue
, and the spline is closed, the spline will make a face, that is, it will appear filled.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)
spline1 = Draft.make_bspline([p1, p2, p3], closed=False)
spline2 = Draft.make_bspline([p1, 2*p3, 1.3*p2], closed=False)
spline3 = Draft.make_bspline([1.3*p3, p1, -1.7*p2], closed=False)
doc.recompute()
- Drafting: Line, Polyline, Fillet, Arc, Arc by 3 points, Circle, Ellipse, Rectangle, Polygon, B-spline, Cubic Bézier curve, Bézier curve, Point, Facebinder, ShapeString, Hatch
- Annotation: Text, Dimension, Label, Annotation styles, Annotation scale
- Modification: Move, Rotate, Scale, Mirror, Offset, Trimex, Stretch, Clone, Array, Polar array, Circular array, Path array, Path link array, Point array, Point link array, Edit, Subelement highlight, Join, Split, Upgrade, Downgrade, Wire to B-spline, Draft to sketch, Set slope, Flip dimension, Shape 2D view
- Draft Tray: Select plane, Set style, Toggle construction mode, AutoGroup
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid
- Miscellaneous: Apply current style, Layer, Manage layers, Add a new named group, Move to group, Select group, Add to construction group, Toggle normal/wireframe display, Create working plane proxy, Heal, Show snap toolbar
- Additional: Constraining, Pattern, Preferences, Import Export Preferences, DXF/DWG, SVG, OCA, DAT
- Context menu:
- Layer container: Merge layer duplicates, Add new layer
- Layer: Activate this layer, Select layer contents
- Text: Open hyperlinks
- Wire: Flatten
- Working plane proxy: Write camera position, Write objects state

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub